cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
	float fog_param0;
	float fog_param1;
};
Buffer<float4> in_pos_buffer : register(t0);
Buffer<float4> in_diff_color_buffer : register(t1);
Buffer<float4> in_tc0_buffer : register(t2);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 in_diff_color = in_diff_color_buffer[vertex_id];
	float4 in_tc0 = in_tc0_buffer[vertex_id];
	float4 in_pos = in_pos_buffer[vertex_id];
	tmp0 = (in_diff_color * vc[4]);
	dst_reg7.xy = in_tc0.xyxx.xy;
	dst_reg0.w = dot(in_pos, vc[3]).xxxx.w;
	dst_reg0.z = dot(in_pos, vc[2]).xxxx.z;
	dst_reg0.y = dot(in_pos, vc[1]).xxxx.y;
	dst_reg0.x = dot(in_pos, vc[0]).xxxx.x;
	dst_reg8.xyz = (tmp0.xyzx * tmp0.wwww).xyz;
	dst_reg8.w = tmp0.wwww.w;

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
